Name:           aria2
Version:        1.17.0
Release:        1
Summary:        High speed download utility with resuming and segmented downloading
Group:          Applications/Internet
License:        GPLv2+ with exceptions
URL:            http://aria2.sourceforge.net/
Source0:        http://downloads.sourceforge.net/%{name}/%{name}-%{version}.tar.bz2
Patch0:         %{name}-%{version}-aix.patch

BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root

BuildRequires:  patch

BuildRequires:  gcc >= 4.2.3-2
BuildRequires:  gcc-c++ >= 4.2.3-2
BuildRequires:  libstdc++-devel >= 4.2.3-2

BuildRequires:  c-ares-devel >= 1.7.1-2
BuildRequires:  gettext
BuildRequires:  gmp-devel >= 4.3.2-1
BuildRequires:  gnutls-devel >= 2.6.6-2
BuildRequires:  libxml2-devel >= 2.6.32-3
BuildRequires:  nettle-devel >= 2.2-1
BuildRequires:  sqlite-devel >= 3.7.3-1
BuildRequires:  zlib-devel >= 1.2.3-3

Requires:  libgcc >= 4.2.3-2
Requires:  libstdc++ >= 4.2.3-2

Requires:  c-ares >= 1.7.1-2
Requires:  gettext
Requires:  gmp >= 4.3.2-1
Requires:  gnutls >= 2.6.6-2
Requires:  libxml2 >= 2.6.32-3
Requires:  nettle >= 2.2-1
Requires:  sqlite >= 3.7.3-1
Requires:  zlib >= 1.2.3-3


%description
aria2 is a download utility with resuming and segmented downloading.
%description
aria2 is a download utility with resuming and segmented downloading.
Supported protocols are HTTP/HTTPS/FTP/BitTorrent. It also supports Metalink
version 3.0.

Currently it has following features:
- HTTP/HTTPS GET support
- HTTP Proxy support
- HTTP BASIC authentication support
- HTTP Proxy authentication support
- FTP support(active, passive mode)
- FTP through HTTP proxy(GET command or tunneling)
- Segmented download
- Cookie support
- It can run as a daemon process.
- BitTorrent protocol support with fast extension.
- Selective download in multi-file torrent
- Metalink version 3.0 support(HTTP/FTP/BitTorrent).
- Limiting download/upload speed


%prep
%setup -q
export PATH=/opt/freeware/bin:$PATH
%patch0


%build
export OBJECT_MODE=64

export CC="gcc -maix64"
export CXX="g++ -maix64"

export CFLAGS="-DSYSV -D_AIX -D_AIX32 -D_AIX41 -D_AIX43 -D_AIX51 -D_ALL_SOURCE -DFUNCPROTO=15 -O -I/opt/freeware/include"

export LDFLAGS="-L/opt/freeware/lib64 -L/opt/freeware/lib -Wl,-blibpath:/opt/freeware/lib64:/opt/freeware/lib:/usr/lib:/lib -Wl,-bmaxdata:0x80000000"

./configure \
    --prefix=%{_prefix} \
    --mandir=%{_mandir} \
    --enable-bittorrent \
    --enable-metalink \
    --enable-epoll\
    --enable-threads=posix \
    --with-gnutls \
    --with-nettle \
    --with-libgmp \
    --with-libcrypt \
    --with-openssl \
    --with-sqlite3 \
    --with-libxml2 \
    --with-libexpat \
    --with-libcares \
    --with-libz \
    --with-libiconv-prefix=%{_prefix} \
    --with-libintl-prefix=%{_prefix}

gmake -j4
make %{?_smp_mflags}

# we need to relink aria2c again as somehow always /opt/freeware/lib is appended# before /opt/freeware/lib64 and thus the 64-bit libstdc++ is not found as it is# located in /opt/freeware/lib64 and not in /opt/freeware/lib!
cd src
rm -f aria2c
g++ -maix64 -qmaxmem=16384 -DSYSV -D_AIX -D_AIX32 -D_AIX41 -D_AIX43 -D_AIX51 -D_ALL_SOURCE -DFUNCPROTO=15 -O -I/opt/freeware/include -Wl,-blibpath:/opt/freeware/lib64:/opt/freeware/lib:/usr/lib:/lib -Wl,-bmaxdata:0x80000000 -o aria2c main.o option_processing.o version_usage.o  -L/opt/freeware/lib64 -L/opt/freeware/lib libaria2c.a ../deps/wslay/lib/.libs/libwslay.a -lcares -lgmp -lnettle -lgnutls -ltasn1 -lgcrypt -lc -lgpg-error  -lintl -lsqlite3 -lxml2 -lpthread -liconv -lm -lz


%install
[ "${RPM_BUILD_ROOT}" != "/" ] && rm -rf ${RPM_BUILD_ROOT}
make install DESTDIR=${RPM_BUILD_ROOT}

/usr/bin/strip -X32_64 ${RPM_BUILD_ROOT}%{_bindir}/* || :

rm -f ${RPM_BUILD_ROOT}%{_datadir}/locale/locale.alias
rm -rf ${RPM_BUILD_ROOT}%{_datadir}/doc/%{name}

cd ${RPM_BUILD_ROOT}
mkdir -p usr/bin
cd usr/bin
ln -sf ../..%{_bindir}/* .


%clean
[ "${RPM_BUILD_ROOT}" != "/" ] && rm -rf ${RPM_BUILD_ROOT}


%files
%doc AUTHORS ChangeLog COPYING README 
%{_bindir}/*
%{_mandir}/man1/*
%{_mandir}/*/man1/*
/usr/bin/*


%changelog
* Sun Apr 21 2013 Michael Perzl <michael@perzl.org> - 1.17.0-1
- updated to version 1.17.0

* Mon Mar 25 2013 Michael Perzl <michael@perzl.org> - 1.16.5-1
- first version for AIX V5.1 and higher
